--[[
	Copyright (C) Udorn (Blackhand)
--]]

petbm = petbm or {}
   
petbm.TooltipHook = petbm.PetBattleMaster:NewModule("TooltipHook", "AceHook-3.0")
local L = petbm.Locale.GetInstance()

local log = petbm.Debug:new("TooltipHook")

local function _ColorizeQuality(text, quality)
	local color = "|C"..select(4, GetItemQualityColor(quality))
	return color..text..FONT_COLOR_CODE_CLOSE;
end

local function OnShow(self, tooltip)
	
	if (self.isShowing) then
		-- avoid self-call
		return
	end
	self.isShowing = true
	
	if (tooltip and tooltip.GetUnit) then
		local name, unit = tooltip:GetUnit()
		if (unit and UnitIsWildBattlePet(unit)) then
			local guid = UnitGUID(unit)
			local creatureId = tonumber(strsub(guid, 7, 10), 16)
			local msg
			for k, pet in petbm.PetStable:GetOwnPets() do
				if (pet.creatureId == creatureId) then
					if (not msg) then
						msg = L["Owned pet: "]
					else
						msg = msg..", "
					end
					local level = select(3, C_PetJournal.GetPetInfoByPetID(pet.petId)) or "?"
					local qstr = _ColorizeQuality(_G["BATTLE_PET_BREED_QUALITY"..pet.quality], pet.quality - 1)
					msg = msg..qstr..L["TOOLTIP_LEVEL"]:format(level)
				end
			end
			
			if (msg) then
				tooltip:AddLine(HIGHLIGHT_FONT_COLOR_CODE..msg..FONT_COLOR_CODE_CLOSE)
			else
				tooltip:AddLine(ORANGE_FONT_COLOR_CODE..L["Missing pet. Go and catch it!"]..FONT_COLOR_CODE_CLOSE)
			end
			
			tooltip:Show() -- update tooltip
		end
	end
	self.isShowing = nil
end

local function OnInitialize(self)
end

local function OnEnable(self)
	log:Debug("OnEnable")
	self:SecureHookScript(GameTooltip, "OnShow")
end

petbm.TooltipHook.OnInitialize = OnInitialize
petbm.TooltipHook.OnEnable = OnEnable
petbm.TooltipHook.OnShow = OnShow
